"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const pal = require("aurelia-pal-nodejs");
const aurelia_loader_nodejs_1 = require("aurelia-loader-nodejs");
const aurelia_framework_1 = require("aurelia-framework");
class Bootstrapper {
    static get aurelia() {
        if (this.instance) {
            return this.instance.aurelia;
        }
        throw new Error('Aurelia instance is undefined');
    }
    static start() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.instance) {
                this.instance = new Bootstrapper();
                this.instance
                    .globalizePal()
                    .createLoader();
            }
            yield this.instance.bootstrap();
            return this.instance.aurelia;
        });
    }
    static dispose() {
        this.instance.aurelia.root.detached();
        this.instance.aurelia.root.unbind();
    }
    constructor() { }
    globalizePal() {
        pal.globalize();
        return this;
    }
    createLoader() {
        this.loader = new aurelia_loader_nodejs_1.NodeJsLoader();
        return this;
    }
    createAureliaInstance() {
        const aurelia = new aurelia_framework_1.Aurelia(this.loader);
        return aurelia;
    }
    bootstrap() {
        return __awaiter(this, void 0, void 0, function* () {
            this.aurelia = this.createAureliaInstance();
            this.aurelia.use
                .defaultBindingLanguage()
                .defaultResources();
            yield this.aurelia.start();
        });
    }
}
exports.Bootstrapper = Bootstrapper;
